/* Subgame I: Space */

void infoscreenI()
{
	if (seeninfo['I']) return;
	seeninfo['I']=1;
	titlepal(gamma);
	memset(shad,0,40*xres);
	memset(shad+40*xres,160,400*xres);
	memset(shad+440*xres,0,40*xres);
	bwrite(60,60,xres,"Subgame I:",15);
	bwrite(60,80,xres,"''Space''",200);
	write(60,100,xres/2-60,"Objective",0,1);
	write(60,110,xres/2-60,"Destroy EVERYTHING!",15,200);
	write(60,120,xres/2-60,"Risks",0,1);
	write(60,130,xres/2-60,"You might hit something and die.",15,200);
	write(60,140,xres/2-60,"Rewards",0,1);
	write(60,150,xres/2-60,"You score points for shooting things.",15,200);
	ccl(0); Sleep(500);
	while (!kbhit && !dealwithmessages());
	writepal(gamma);
}

typedef struct sgI_player
{
	int x1,x2,y1,y2; // Clipping rectangle
	double x,y,z,xs,ys,zs; // Position and speed
	double a11,a12,a13,a21,a22,a23,a31,a32,a33; // Rotation matrix
	double w1,w2,w3; // Angular velocity vector
	unsigned char cs,cb; // Ship and bullet colours
} sgI_player;

typedef struct sgI_thing
{
	enum {Bullet,Asteroid} t; // Type
	int s; // Size
	double x,y,z,xs,ys,zs; // Position and speed
	double w1,w2,w3; // Angular velocity
	unsigned char c; // Colour
} sgI_thing;

const double sgI_ez=0.001;

void point3d(double rx,double ry,double rz,const sgI_player p,const unsigned char c)
{
	double x,y,z,k; int px,py;
	rx-=p.x; ry-=p.y; rz-=p.z;
	z=p.a31*rx+p.a32*ry+p.a33*rz;
	if (z<sgI_ez) return;
	x=p.a11*rx+p.a12*ry+p.a13*rz;
	y=p.a21*rx+p.a22*ry+p.a23*rz;
	k=(double)(p.y2-p.y1)/z;
	px=(p.x1+p.x2)/2+x*k;
	py=(p.y1+p.y2)/2+y*k;
	if (px>=p.x1 && px<p.x2 && py>=p.y1 && py<p.y2) putpix(px,py,c);
}

void line3d(double rx1,double ry1,double rz1,double rx2,double ry2,double rz2,const sgI_player p,const unsigned char c)
{
	double x1,y1,z1,x2,y2,z2,px1,py1,px2,py2,k,kk;
	rx1-=p.x; ry1-=p.y; rz1-=p.z; rx2-=p.x; ry2-=p.y; rz2-=p.z;
	x1=p.a11*rx1+p.a12*ry1+p.a13*rz1;
	y1=p.a21*rx1+p.a22*ry1+p.a23*rz1;
	z1=p.a31*rx1+p.a32*ry1+p.a33*rz1;
	x2=p.a11*rx2+p.a12*ry2+p.a13*rz2;
	y2=p.a21*rx2+p.a22*ry2+p.a23*rz2;
	z2=p.a31*rx2+p.a32*ry2+p.a33*rz2;
	if (z1<sgI_ez)
	{
		if (z2<sgI_ez) return;
		k=(sgI_ez-z1)/(z2-z1);
		x1+=k*(x2-x1); y1+=k*(y2-y1);
		z1=sgI_ez;
	}
	else if (z2<sgI_ez)
	{
		k=(sgI_ez-z2)/(z1-z2);
		x2+=k*(x1-x2); y2+=k*(y1-y2);
		z2=sgI_ez;
	}
	k=(double)(p.y2-p.y1)/z1; kk=(double)(p.y2-p.y1)/z2;
	line((p.x1+p.x2)/2+x1*k,(p.y1+p.y2)/2+y1*k,(p.x1+p.x2)/2+x2*kk,(p.y1+p.y2)/2+y2*kk,c);
}

void plotfor(const sgI_thing t,const sgI_player p)
{
	if (t.t==Bullet)
	{
		line3d(t.x,t.y,t.z,t.x+t.xs,t.y+t.ys,t.z+t.zs,p,t.c);
	}
	else if (t.t==Asteroid)
	{
		int n;
		for (n=0;n<100;n++) // Rubbish temporary way of drawing an asteroid
		{
			double x,y,z,dd;
			do {x=frnd(2)-1; y=frnd(2)-1; z=frnd(2)-1;} while ((dd=x*x+y*y+z*z)>1);
			dd=pow(t.s,1.0/3)/sqrt(dd)/2; x*=dd; y*=dd; z*=dd;
			point3d(t.x+x,t.y+y,t.z+z,p,t.c);
		}
	}
}

void advancething(sgI_thing *t,const double dt)
{
	t->x+=t->xs*dt; t->y+=t->ys*dt; t->z+=t->zs*dt;
}

void advanceplayer(sgI_player *p,const double dt)
{
	int n,i;
	double a=p->w1*dt,b=p->w2*dt,c=p->w3*dt;
	sgI_player q;
	p->x+=p->xs*dt; p->y+=p->ys*dt; p->z+=p->zs*dt;
	i=Max(Max(1,fabs(a*10)),Max(fabs(b*10),fabs(c*10)));
	for (n=0;n<i;n++)
	{
		a=p->w1*dt/i; b=p->w2*dt/i; c=p->w3*dt/i;
		q=*p;
		p->a11+=c*q.a21+b*q.a31; p->a21+=-c*q.a11+a*q.a31; p->a31+=-b*q.a11-a*q.a21;
		p->a12+=c*q.a22+b*q.a32; p->a22+=-c*q.a12+a*q.a32; p->a32+=-b*q.a12-a*q.a22;
		p->a13+=c*q.a23+b*q.a33; p->a23+=-c*q.a13+a*q.a33; p->a33+=-b*q.a13-a*q.a23;
		q=*p;
		a=0.5*(q.a11*q.a12+q.a21*q.a22+q.a31*q.a32);
		b=0.5*(q.a11*q.a13+q.a21*q.a23+q.a31*q.a33);
		c=0.5*(q.a12*q.a13+q.a22*q.a23+q.a32*q.a33);
		p->a11-=a*q.a12+b*q.a13; p->a12-=a*q.a11+c*q.a13; p->a13-=b*q.a11+c*q.a12;
		p->a21-=a*q.a22+b*q.a23; p->a22-=a*q.a21+c*q.a23; p->a23-=b*q.a21+c*q.a22;
		p->a31-=a*q.a32+b*q.a33; p->a32-=a*q.a31+c*q.a33; p->a33-=b*q.a31+c*q.a32;
		q=*p;
		a=sqrt(sq(q.a11)+sq(q.a21)+sq(q.a31));
		b=sqrt(sq(q.a12)+sq(q.a22)+sq(q.a32));
		c=sqrt(sq(q.a13)+sq(q.a23)+sq(q.a33));
		p->a11/=a; p->a21/=a; p->a31/=a;
		p->a12/=b; p->a22/=b; p->a32/=b;
		p->a13/=c; p->a23/=c; p->a33/=c;
	}
	p->w1*=pow(0.8,dt); p->w2*=pow(0.8,dt); p->w3*=pow(0.8,dt);
	//line(xres/2,yres/2,xres/2+p->a11*100,yres/2+p->a21*100,15);
	//line(xres/2,yres/2,xres/2+p->a12*100,yres/2+p->a22*100,15);
	//line(xres/2,yres/2,xres/2+p->a13*100,yres/2+p->a23*100,15);
}

enum sg_retcode subgameI(const int them) /* 3D version of distribution 2a */
{
	int n,i,k;
	sgI_player p[MAXP];
	int am=0,amax=1000;
	sgI_thing *a=(sgI_thing *)malloc(amax*sizeof(sgI_thing));
	int blank=0;
	double dt=1;
	enum sg_retcode ret=TBA;
	infoscreenI();
	i=0; for participants(k)
	{
		n=((them>>3)&1)+((them>>2)&1)+((them>>1)&1)+(them&1);
		p[k].x=sin(M_TWOPI*k/n); p[k].y=cos(M_TWOPI*k/n); p[k].z=0;
		p[k].a11=p[k].a22=p[k].a33=1;
		p[k].a12=p[k].a13=p[k].a21=p[k].a23=p[k].a31=p[k].a32=0;
		p[k].w1=p[k].w2=p[k].w3=0;
		p[k].cs=15; p[k].cb=12;
		if (n==1) {p[k].x1=p[k].y1=0; p[k].x2=xres; p[k].y2=yres;}
		else if (n==2) {p[k].x1=i*xres/2; p[k].y1=yres/4;}
		else {p[k].x1=i%2*xres/2; p[k].y1=i/2*yres/2;}
		if (n==3 && i==2) p[k].x1=xres/4;
		if (n>=2) {p[k].x2=p[k].x1+xres/2; p[k].y2=p[k].y1+yres/2;}
		i++;
	}
	while (ret==TBA)
	{
		double framestart=GetTickCount();
		int idt=(int)floor(dt+0.5);
		for every_enemy(n) advancething(&a[n],dt);
		for participants(k)
		{
			if (KEY(leftkey[k])) p[k].w2+=0.005*dt;
			if (KEY(rightkey[k])) p[k].w2-=0.005*dt;
			if (KEY(downkey[k])) p[k].w1-=0.005*dt;
			if (KEY(upkey[k])) p[k].w1+=0.005*dt;
			if (KEY(selectkey[k]))
			{
				p[k].xs+=0.01*p[k].a31*dt;
				p[k].ys+=0.01*p[k].a32*dt;
				p[k].zs+=0.01*p[k].a33*dt;
			}
			advanceplayer(&p[k],dt);
			for every_enemy(n) plotfor(a[n],p[k]);
		}
		if (!am) blank+=idt; else blank=0;
		if (blank>=300)
		{
			am=3+ilevel;
			for every_enemy(n)
			{
				a[n].t=Asteroid; a[n].s=25;
				a[n].x=frnd(20)-10; a[n].y=frnd(20)-10; a[n].z=frnd(20)-10;
				a[n].xs=frnd(0.02)-0.01; a[n].ys=frnd(0.02)-0.01; a[n].zs=frnd(0.02)-0.01;
				a[n].w1=frnd(0.2)-0.1; a[n].w2=frnd(0.2)-0.1; a[n].w3=frnd(0.2)-0.1;
				a[n].c=7;
			}
		}
		ccl(0);
		do
		{
			if (dealwithmessages()) ret=Error;
			if (KEY(VK_ESCAPE)) ret=Quit;
		}
		while (ret==TBA && GetTickCount()<framestart+mswait);
		dt=Max(Min((float)(GetTickCount()-framestart)/mswait,20),1);
	}
	return Pass;
}
